diff -r f40675df5d4c trytond/modules/account/move.py
--- a/trytond/modules/account/move.py	Fri Sep 21 15:57:18 2012 +0200
+++ b/trytond/modules/account/move.py	Mon Sep 24 20:36:38 2012 +0200
@@ -11,8 +11,16 @@
 from trytond.backend import TableHandler, FIELDS
 from trytond.pyson import Eval, PYSONEncoder
 from trytond.transaction import Transaction
-from trytond.pool import Pool
+from trytond.pool import Pool, PoolMeta
 from trytond.config import CONFIG
+from trytond.rpc import RPC
+
+__all__ = ['Move', 'Reconciliation', 'Line', 'Move2', 'OpenJournalAsk',
+    'OpenJournal', 'OpenAccount', 'ReconcileLinesWriteOff', 'ReconcileLines',
+    'UnreconcileLinesStart', 'UnreconcileLines', 'OpenReconcileLinesStart',
+    'OpenReconcileLines', 'FiscalYearLine', 'FiscalYear2',
+    'PrintGeneralJournalStart', 'PrintGeneralJournal', 'GeneralJournal']
+__metaclass__ = PoolMeta
 
 _MOVE_STATES = {
     'readonly': Eval('state') == 'posted',
@@ -26,9 +34,7 @@
 
 class Move(ModelSQL, ModelView):
     'Account Move'
-    _name = 'account.move'
-    _description = __doc__
-
+    __name__ = 'account.move'
     name = fields.Char('Name', size=None, required=True, states=_MOVE_STATES,
             depends=_MOVE_DEPENDS)
     reference = fields.Char('Reference', size=None, readonly=True,
@@ -52,17 +58,18 @@
                 'date': Eval('date'),
             })
 
-    def __init__(self):
-        super(Move, self).__init__()
-        self._check_modify_exclude = ['state']
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Move, cls).__setup__()
+        cls._check_modify_exclude = ['state']
+        cls._constraints += [
             ('check_centralisation', 'period_centralized_journal'),
             ('check_company', 'company_in_move'),
             ('check_date', 'date_outside_period'),
         ]
-        self._order.insert(0, ('date', 'DESC'))
-        self._order.insert(1, ('reference', 'DESC'))
-        self._error_messages.update({
+        cls._order.insert(0, ('date', 'DESC'))
+        cls._order.insert(1, ('reference', 'DESC'))
+        cls._error_messages.update({
             'del_posted_move': 'You can not delete posted moves!',
             'post_empty_move': 'You can not post an empty move!',
             'post_unbalanced_move': 'You can not post an unbalanced move!',
@@ -80,7 +87,7 @@
             'draft_closed_period': 'You can not set to draft a move ' \
                     'from a closed period',
             })
-        self._buttons.update({
+        cls._buttons.update({
                 'post': {
                     'invisible': Eval('state') == 'posted',
                     },
@@ -89,184 +96,166 @@
                     },
                 })
 
-    def init(self, module_name):
-        super(Move, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(Move, cls).__register__(module_name)
 
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         table.index_action(['journal', 'period'], 'add')
 
         # Add index on create_date
         table.index_action('create_date', action='add')
 
-    def default_period(self):
-        period_obj = Pool().get('account.period')
-        return period_obj.find(Transaction().context.get('company'),
-                exception=False)
+    @staticmethod
+    def default_period():
+        Period = Pool().get('account.period')
+        return Period.find(Transaction().context.get('company'),
+            exception=False)
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_date(self):
-        period_obj = Pool().get('account.period')
-        date_obj = Pool().get('ir.date')
-        period_id = self.default_period()
+    @classmethod
+    def default_date(cls):
+        pool = Pool()
+        Period = pool.get('account.period')
+        Date = pool.get('ir.date')
+        period_id = cls.default_period()
         if period_id:
-            period = period_obj.browse(period_id)
+            period = Period(period_id)
             return period.start_date
-        return date_obj.today()
+        return Date.today()
 
-    def on_change_with_date(self, vals):
-        line_obj = Pool().get('account.move.line')
-        period_obj = Pool().get('account.period')
-        res = vals['date']
-        line_ids = line_obj.search([
-            ('journal', '=', vals.get('journal')),
-            ('period', '=', vals.get('period')),
-            ], order=[('id', 'DESC')], limit=1)
-        if line_ids:
-            line = line_obj.browse(line_ids[0])
-            res = line.date
-        elif vals.get('period'):
-            period = period_obj.browse(vals['period'])
-            res = period.start_date
-        return res
+    def on_change_with_date(self):
+        Line = Pool().get('account.move.line')
+        date = self.date
+        lines = Line.search([
+                ('journal', '=', self.journal),
+                ('period', '=', self.period),
+                ], order=[('id', 'DESC')], limit=1)
+        if lines:
+            date = lines[0].date
+        elif self.period:
+            date = self.period.start_date
+        return date
 
-    def check_centralisation(self, ids):
-        for move in self.browse(ids):
-            if move.journal.centralised:
-                move_ids = self.search([
-                    ('period', '=', move.period.id),
-                    ('journal', '=', move.journal.id),
+    def check_centralisation(self):
+        if self.journal.centralised:
+            moves = self.search([
+                    ('period', '=', self.period.id),
+                    ('journal', '=', self.journal.id),
                     ('state', '!=', 'posted'),
                     ], limit=2)
-                if len(move_ids) > 1:
-                    return False
-        return True
-
-    def check_company(self, ids):
-        for move in self.browse(ids):
-            company_id = -1
-            for line in move.lines:
-                if company_id < 0:
-                    company_id = line.account.company.id
-                if line.account.company.id != company_id:
-                    return False
-        return True
-
-    def check_date(self, ids):
-        for move in self.browse(ids):
-            if move.date < move.period.start_date:
-                return False
-            if move.date > move.period.end_date:
+            if len(moves) > 1:
                 return False
         return True
 
-    def check_modify(self, ids):
+    def check_company(self):
+        company_id = -1
+        for line in self.lines:
+            if company_id < 0:
+                company_id = line.account.company.id
+            if line.account.company.id != company_id:
+                return False
+        return True
+
+    def check_date(self):
+        return self.period.start_date <= self.date <= self.period.end_date
+
+    @classmethod
+    def check_modify(cls, moves):
         'Check posted moves for modifications.'
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        for move in self.browse(ids):
+        for move in moves:
             if move.state == 'posted':
-                self.raise_user_error('modify_posted_move',
+                cls.raise_user_error('modify_posted_move',
                     error_args=(move.name,))
-        return
 
-    def search_rec_name(self, name, clause):
-        ids = self.search(['OR',
-            ('reference',) + tuple(clause[1:]),
-            (self._rec_name,) + tuple(clause[1:]),
-            ])
-        return [('id', 'in', ids)]
+    @classmethod
+    def search_rec_name(cls, name, clause):
+        moves = cls.search(['OR',
+                ('reference',) + tuple(clause[1:]),
+                (cls._rec_name,) + tuple(clause[1:]),
+                ])
+        return [('id', 'in', [m.id for m in moves])]
 
-    def write(self, ids, vals):
+    @classmethod
+    def write(cls, moves, vals):
         keys = vals.keys()
-        for key in self._check_modify_exclude:
+        for key in cls._check_modify_exclude:
             if key in keys:
                 keys.remove(key)
         if len(keys):
-            self.check_modify(ids)
-        res = super(Move, self).write(ids, vals)
-        self.validate(ids)
-        return res
+            cls.check_modify(moves)
+        super(Move, cls).write(moves, vals)
+        cls.validate(moves)
 
-    def create(self, vals):
+    @classmethod
+    def create(cls, vals):
         pool = Pool()
-        move_line_obj = pool.get('account.move.line')
-        sequence_obj = pool.get('ir.sequence')
-        journal_obj = pool.get('account.journal')
+        MoveLine = pool.get('account.move.line')
+        Sequence = pool.get('ir.sequence')
+        Journal = pool.get('account.journal')
 
         if not vals.get('name'):
             journal_id = (vals.get('journal')
                     or Transaction().context.get('journal'))
             if journal_id:
                 vals = vals.copy()
-                journal = journal_obj.browse(journal_id)
-                vals['name'] = sequence_obj.get_id(journal.sequence.id)
+                journal = Journal(journal_id)
+                vals['name'] = Sequence.get_id(journal.sequence.id)
 
-        res = super(Move, self).create(vals)
-        move = self.browse(res)
+        move = super(Move, cls).create(vals)
         if move.journal.centralised:
-            line_id = move_line_obj.create({
-                'account': move.journal.credit_account.id,
-                'move': move.id,
-                'name': 'Centralised Counterpart',
-                })
-            self.write(move.id, {
-                'centralised_line': line_id,
-                })
+            line = MoveLine.create({
+                    'account': move.journal.credit_account.id,
+                    'move': move.id,
+                    'name': 'Centralised Counterpart',
+                    })
+            cls.write([move], {
+                    'centralised_line': line.id,
+                    })
         if 'lines' in vals:
-            self.validate([res])
-        return res
+            cls.validate([move])
+        return move
 
-    def delete(self, ids):
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        move_line_obj = Pool().get('account.move.line')
-        self.check_modify(ids)
-        for move in self.browse(ids):
-            if move.lines:
-                move_line_ids = [x.id for x in move.lines]
-                move_line_obj.delete(move_line_ids)
-        return super(Move, self).delete(ids)
+    @classmethod
+    def delete(cls, moves):
+        MoveLine = Pool().get('account.move.line')
+        cls.check_modify(moves)
+        MoveLine.delete([l for m in moves for l in m.lines])
+        super(Move, cls).delete(moves)
 
-    def copy(self, ids, default=None):
-        line_obj = Pool().get('account.move.line')
-
-        int_id = False
-        if isinstance(ids, (int, long)):
-            int_id = True
-            ids = [ids]
+    @classmethod
+    def copy(cls, moves, default=None):
+        Line = Pool().get('account.move.line')
 
         if default is None:
             default = {}
         default = default.copy()
         default['reference'] = None
-        default['state'] = self.default_state()
+        default['state'] = cls.default_state()
         default['post_date'] = None
         default['lines'] = None
 
-        new_ids = []
-        for move in self.browse(ids):
-            new_id = super(Move, self).copy(move.id, default=default)
-            line_obj.copy([x.id for x in move.lines], default={
-                'move': new_id,
-                })
-            new_ids.append(new_id)
+        new_moves = []
+        for move in moves:
+            new_move, = super(Move, cls).copy([move], default=default)
+            Line.copy(move.lines, default={
+                    'move': new_move.id,
+                    })
+            new_moves.append(new_move)
+        return new_moves
 
-        if int_id:
-            return new_ids[0]
-        return new_ids
-
-    def validate(self, ids):
+    @classmethod
+    def validate(cls, moves):
         '''
         Validate balanced move and centralise it if in centralised journal
         '''
-        currency_obj = Pool().get('currency.currency')
-        move_line_obj = Pool().get('account.move.line')
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-        for move in self.browse(ids):
+        pool = Pool()
+        MoveLine = pool.get('account.move.line')
+        for move in moves:
             if not move.lines:
                 continue
             amount = Decimal('0.0')
@@ -278,10 +267,10 @@
                     company = line.account.company
                 if line.state == 'draft':
                     draft_lines.append(line)
-            if not currency_obj.is_zero(company.currency, amount):
+            if not company.currency.is_zero(amount):
                 if not move.journal.centralised:
-                    move_line_obj.write(
-                            [x.id for x in move.lines if x.state != 'draft'], {
+                    MoveLine.write(
+                            [x for x in move.lines if x.state != 'draft'], {
                                 'state': 'draft',
                                 })
                 else:
@@ -300,18 +289,18 @@
                         credit = - centralised_amount
                         account_id = move.journal.credit_account.id
                     if not move.centralised_line:
-                        centralised_line_id = move_line_obj.create({
+                        centralised_line = MoveLine.create({
                             'debit': debit,
                             'credit': credit,
                             'account': account_id,
                             'move': move.id,
                             'name': 'Centralised Counterpart',
                             })
-                        self.write(move.id, {
-                            'centralised_line': centralised_line_id,
+                        cls.write([move], {
+                            'centralised_line': centralised_line.id,
                             })
                     else:
-                        move_line_obj.write(move.centralised_line.id, {
+                        MoveLine.write([move.centralised_line], {
                                 'debit': debit,
                                 'credit': credit,
                                 'account': account_id,
@@ -319,71 +308,63 @@
                 continue
             if not draft_lines:
                 continue
-            move_line_obj.write([x.id for x in draft_lines], {
+            MoveLine.write(draft_lines, {
                     'state': 'valid',
                     })
-        return
 
+    @classmethod
     @ModelView.button
-    def post(self, ids):
+    def post(cls, moves):
         pool = Pool()
-        currency_obj = pool.get('currency.currency')
-        sequence_obj = pool.get('ir.sequence')
-        date_obj = pool.get('ir.date')
+        Sequence = pool.get('ir.sequence')
+        Date = pool.get('ir.date')
 
-        if isinstance(ids, (int, long)):
-            ids = [ids]
-
-        moves = self.browse(ids)
         for move in moves:
             amount = Decimal('0.0')
             if not move.lines:
-                self.raise_user_error('post_empty_move')
+                cls.raise_user_error('post_empty_move')
             company = None
             for line in move.lines:
                 amount += line.debit - line.credit
                 if not company:
                     company = line.account.company
-            if not currency_obj.is_zero(company.currency, amount):
-                self.raise_user_error('post_unbalanced_move')
+            if not company.currency.is_zero(amount):
+                cls.raise_user_error('post_unbalanced_move')
         for move in moves:
-            reference = sequence_obj.get_id(move.period.post_move_sequence.id)
-            self.write(move.id, {
+            reference = Sequence.get_id(move.period.post_move_sequence.id)
+            cls.write([move], {
                 'reference': reference,
                 'state': 'posted',
-                'post_date': date_obj.today(),
+                'post_date': Date.today(),
                 })
-        return
 
+    @classmethod
     @ModelView.button
-    def draft(self, ids):
-        for move in self.browse(ids):
+    def draft(cls, moves):
+        for move in moves:
             if not move.journal.update_posted:
-                self.raise_user_error('draft_posted_move_journal')
+                cls.raise_user_error('draft_posted_move_journal')
             if move.period.state == 'close':
-                self.raise_user_error('draft_closed_period')
-        return self.write(ids, {
+                cls.raise_user_error('draft_closed_period')
+        return cls.write(moves, {
             'state': 'draft',
             })
 
-Move()
-
 
 class Reconciliation(ModelSQL, ModelView):
     'Account Move Reconciliation Lines'
-    _name = 'account.move.reconciliation'
-    _description = __doc__
-
+    __name__ = 'account.move.reconciliation'
     name = fields.Char('Name', size=None, required=True)
     lines = fields.One2Many('account.move.line', 'reconciliation',
             'Lines')
 
-    def __init__(self):
-        super(Reconciliation, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Reconciliation, cls).__setup__()
+        cls._constraints += [
             ('check_lines', 'invalid_reconciliation'),
-        ]
-        self._error_messages.update({
+            ]
+        cls._error_messages.update({
             'modify': 'You can not modify a reconciliation!',
             'invalid_reconciliation': 'You can not create reconciliation ' \
                     'where lines are not balanced, nor valid, ' \
@@ -391,21 +372,23 @@
                     'nor from the same party!',
             })
 
-    def create(self, vals):
-        sequence_obj = Pool().get('ir.sequence')
+    @classmethod
+    def create(cls, vals):
+        Sequence = Pool().get('ir.sequence')
 
         if 'name' not in vals:
             vals = vals.copy()
-            vals['name'] = sequence_obj.get('account.move.reconciliation')
+            vals['name'] = Sequence.get('account.move.reconciliation')
 
-        return super(Reconciliation, self).create(vals)
+        return super(Reconciliation, cls).create(vals)
 
-    def write(self, ids, vals):
-        self.raise_user_error('modify')
+    @classmethod
+    def write(cls, moves, vals):
+        cls.raise_user_error('modify')
 
-    def check_lines(self, ids):
-        currency_obj = Pool().get('currency.currency')
-        for reconciliation in self.browse(ids):
+    @classmethod
+    def check_lines(cls, reconciliations):
+        for reconciliation in reconciliations:
             amount = Decimal('0.0')
             account = None
             party = None
@@ -423,18 +406,14 @@
                     party = line.party
                 elif line.party and party.id != line.party.id:
                     return False
-            if not currency_obj.is_zero(account.company.currency, amount):
+            if not account.company.currency.is_zero(amount):
                 return False
         return True
 
-Reconciliation()
-
 
 class Line(ModelSQL, ModelView):
     'Account Move Line'
-    _name = 'account.move.line'
-    _description = __doc__
-
+    __name__ = 'account.move.line'
     name = fields.Char('Name', size=None, required=True)
     debit = fields.Numeric('Debit', digits=(16, Eval('currency_digits', 2)),
         required=True,
@@ -497,21 +476,22 @@
     second_currency_digits = fields.Function(fields.Integer(
         'Second Currency Digits'), 'get_currency_digits')
 
-    def __init__(self):
-        super(Line, self).__init__()
-        self._sql_constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Line, cls).__setup__()
+        cls._sql_constraints += [
             ('credit_debit',
                 'CHECK(credit * debit = 0.0)',
                 'Wrong credit/debit values!'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_account', 'move_view_inactive_account'),
-        ]
-        self._rpc.update({
-            'on_write': False,
-        })
-        self._order[0] = ('id', 'DESC')
-        self._error_messages.update({
+            ]
+        cls.__rpc__.update({
+                'on_write': RPC(instantiate=0),
+                })
+        cls._order[0] = ('id', 'DESC')
+        cls._error_messages.update({
             'add_modify_closed_journal_period': 'You can not ' \
                     'add/modify lines in a closed journal period!',
             'modify_posted_move': 'You can not modify lines of a posted move!',
@@ -522,64 +502,71 @@
             'already_reconciled': 'Line "%s" (%d) already reconciled!',
             })
 
-    def init(self, module_name):
-        super(Line, self).init(module_name)
+    @classmethod
+    def __register__(cls, module_name):
+        super(Line, cls).__register__(module_name)
 
         cursor = Transaction().cursor
-        table = TableHandler(cursor, self, module_name)
+        table = TableHandler(cursor, cls, module_name)
         # Index for General Ledger
         table.index_action(['move', 'account'], 'add')
 
         # Migration from 1.2
         table.not_null_action('blocked', action='remove')
 
-    def default_date(self):
+    @classmethod
+    def default_date(cls):
         '''
         Return the date of the last line for journal, period
         or the starting date of the period
         or today
         '''
-        period_obj = Pool().get('account.period')
-        date_obj = Pool().get('ir.date')
+        pool = Pool()
+        Period = pool.get('account.period')
+        Date = pool.get('ir.date')
 
-        res = date_obj.today()
-        line_ids = self.search([
-            ('journal', '=', Transaction().context.get('journal')),
-            ('period', '=', Transaction().context.get('period')),
-            ], order=[('id', 'DESC')], limit=1)
-        if line_ids:
-            line = self.browse(line_ids[0])
-            res = line.date
+        date = Date.today()
+        lines = cls.search([
+                ('journal', '=', Transaction().context.get('journal')),
+                ('period', '=', Transaction().context.get('period')),
+                ], order=[('id', 'DESC')], limit=1)
+        if lines:
+            date = lines[0].date
         elif Transaction().context.get('period'):
-            period = period_obj.browse(Transaction().context['period'])
-            res = period.start_date
+            period = Period(Transaction().context['period'])
+            date = period.start_date
         if Transaction().context.get('date'):
-            res = Transaction().context['date']
-        return res
+            date = Transaction().context['date']
+        return date
 
-    def default_state(self):
+    @staticmethod
+    def default_state():
         return 'draft'
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def default_currency_digits(self):
+    @staticmethod
+    def default_currency_digits():
         return 2
 
-    def default_debit(self):
+    @staticmethod
+    def default_debit():
         return Decimal(0)
 
-    def default_credit(self):
+    @staticmethod
+    def default_credit():
         return Decimal(0)
 
-    def default_get(self, fields, with_rec_name=True):
+    @classmethod
+    def default_get(cls, fields, with_rec_name=True):
         pool = Pool()
-        move_obj = pool.get('account.move')
-        tax_obj = pool.get('account.tax')
-        account_obj = pool.get('account.account')
-        tax_code_obj = pool.get('account.tax.code')
-        currency_obj = pool.get('currency.currency')
-        values = super(Line, self).default_get(fields,
+        Move = pool.get('account.move')
+        Tax = pool.get('account.tax')
+        Account = pool.get('account.account')
+        TaxCode = pool.get('account.tax.code')
+        values = super(Line, cls).default_get(fields,
                 with_rec_name=with_rec_name)
 
         if 'move' not in fields:
@@ -591,21 +578,20 @@
 
         if (Transaction().context.get('journal')
                 and Transaction().context.get('period')):
-            line_ids = self.search([
+            lines = cls.search([
                 ('move.journal', '=', Transaction().context['journal']),
                 ('move.period', '=', Transaction().context['period']),
                 ('create_uid', '=', Transaction().user),
                 ('state', '=', 'draft'),
                 ], order=[('id', 'DESC')], limit=1)
-            if not line_ids:
+            if not lines:
                 return values
-            line = self.browse(line_ids[0])
-            values['move'] = line.move.id
+            values['move'] = lines[0].move.id
 
         if 'move' not in values:
             return values
 
-        move = move_obj.browse(values['move'])
+        move = Move(values['move'])
         total = Decimal('0.0')
         taxes = {}
         no_code_taxes = []
@@ -682,8 +668,7 @@
                             key = 'credit_note'
                     line_amount = Decimal('0.0')
                     tax_amount = Decimal('0.0')
-                    for tax_line in tax_obj.compute(
-                            [x.id for x in line.account.taxes],
+                    for tax_line in Tax.compute(line.account.taxes,
                             line.debit or line.credit, 1):
                         if (tax_line['tax'][key + '_account'].id \
                                 or line.account.id) == account_id \
@@ -696,10 +681,10 @@
                                 line_amount -= tax_line['amount']
                             tax_amount += tax_line['amount'] * \
                                     tax_line['tax'][key + '_tax_sign']
-                    line_amount = currency_obj.round(
-                            line.account.company.currency, line_amount)
-                    tax_amount = currency_obj.round(
-                            line.account.company.currency, tax_amount)
+                    line_amount = line.account.company.currency.round(
+                        line_amount)
+                    tax_amount = line.account.company.currency.round(
+                        tax_amount)
                     if ('debit' in fields):
                         values['debit'] = line_amount > Decimal('0.0') \
                                 and line_amount or Decimal('0.0')
